// VaxVoIP.cpp: implementation of the CVaxVoIP class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VCSample.h"
#include "VaxVoIP.h"
#include "VCSampleDlg.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVaxVoIP::CVaxVoIP()
{

}

CVaxVoIP::~CVaxVoIP()
{

}


void CVaxVoIP::ErrorMessage()
{
	DWORD dwError = GetLastError();

	CWnd* pParentWnd = AfxGetMainWnd();
	
	if(dwError == 10)
	{
		pParentWnd->MessageBox("You are not online, please click the 'Online' button first to make and/or receive the requests", "Online", MB_ICONEXCLAMATION);
	}

	else if(dwError == 11)
	{
		pParentWnd->MessageBox("You are already in the conversation, please disconnect it first", "Already connected", MB_ICONEXCLAMATION);
	}

	else if(dwError == 12)
	{
		pParentWnd->MessageBox("Conversation is already connecting, please disconnect it first", "Already connecting", MB_ICONEXCLAMATION);
	}

	else if(dwError == 13)
	{
		pParentWnd->MessageBox("Cann't access Input/Mic device or device is already in use", "Input Device Problem", MB_ICONEXCLAMATION);
	}

	else if(dwError == 14)
	{
		pParentWnd->MessageBox("Cann't access Output/Speaker device or device is already in use", "Output Device Problem", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 15)
	{
		pParentWnd->MessageBox("Invalid IP and/or Port to Accept the conversation request", "Incoming Request", MB_ICONEXCLAMATION);
	}

	else if(dwError == 16)
	{
		pParentWnd->MessageBox("Cannot open local communication port or Port is already in use", "Local Port Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 17)
	{
		pParentWnd->MessageBox("Invalid License Key", "License Key", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 18)
	{
		pParentWnd->MessageBox("Recording Media Initialization Error", "Recording Media Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 19)
	{
		pParentWnd->MessageBox("Cannot open the recording channel", "Recording Channel", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 20)
	{
		pParentWnd->MessageBox("Cannot open the file", "Save Recording to wave file Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 21)
	{
		pParentWnd->MessageBox("Already adding into the conference", "Conference", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 22)
	{
		pParentWnd->MessageBox("Already in the conversation", "Conversation", MB_ICONEXCLAMATION);
	}

	else if(dwError == 23)
	{
		pParentWnd->MessageBox("Please start the conversation first by clicking 'Start Conversation' button, then you can add more persons into the conversation", "Conference", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 24)
	{
		pParentWnd->MessageBox("Voice compression manager intialization error", "Voice Compression Manager", MB_ICONEXCLAMATION);
	}

	else if(dwError == 25)
	{
		pParentWnd->MessageBox("Task manager intialization error", "Task Manager Window", MB_ICONEXCLAMATION);
	}
}


void CVaxVoIP::OnStatusEvent(DWORD dwStatusCode, CString sIP, UINT nPort)
{
	
	CWnd* pCallStatusWnd = AfxGetMainWnd()->GetDlgItem(IDC_STATIC_CALLSTATUS);
		
	switch (dwStatusCode)
	{
		case 50:
			pCallStatusWnd->SetWindowText("Failed to connect to Person [IP: " + sIP + "]");
			break;
		
		case 51:
			pCallStatusWnd->SetWindowText("Connecting to Person [IP: " + sIP + "]");
			break;

		case 52:
			pCallStatusWnd->SetWindowText("Connection lost to Person [IP: " + sIP + "]");
			break;

		case 53:
			pCallStatusWnd->SetWindowText("Successfully connected to Person [IP: " + sIP + "]" + ", you may start conversation now");
			break;

		case 54:
			pCallStatusWnd->SetWindowText("Conversation closed by the Person [IP: " + sIP + "]");
			break;

		case 55:
			pCallStatusWnd->SetWindowText("Person to which you are trying to connect is busy");
			break;

		case 56:
			pCallStatusWnd->SetWindowText("Person to which you are trying to connect is not available");
			break;

		case 57:
			pCallStatusWnd->SetWindowText("Conversation request cancelled by the other party");
			break;
		
		case 58:
			pCallStatusWnd->SetWindowText("Person [IP: " + sIP + "]" + " is already having the conversation");
			break;

		case 59:
			pCallStatusWnd->SetWindowText("Adding Person [IP: " + sIP + "]" + " in the conversation");
			break;

		case 60:
			pCallStatusWnd->SetWindowText("Successfully Added Person [IP: " + sIP + "]" + " in the conversation");
			break;

		case 61:
			pCallStatusWnd->SetWindowText("Person [IP: " + sIP + "]" + " has cancelled the add conference request");
			break;

		case 62:
			pCallStatusWnd->SetWindowText("Adding Person [IP: " + sIP + "]" + " in conversation failed");
			break;

	}
}

void CVaxVoIP::OnTextEvent(CString sTextMsg, CString sIP, UINT nPort)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();

	pParentWnd->m_ReceiveTxtListBox.AddString(sIP + ": " + sTextMsg);

}


void CVaxVoIP::OnConnectionEvent(CString sIP, UINT nPort)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();
	
	if(pParentWnd->MessageBox("You have an incoming start conversation request, Do you want to accept?", "Incoming request from IP: " + sIP, MB_ICONEXCLAMATION|MB_YESNO) == IDYES)
	{
		if(!AcceptIncomingCall(sIP, nPort, 20))
		{
			ErrorMessage();
		}
	}
	else
	{
		if(!CancelIncomingCall(sIP, nPort))
		{
			ErrorMessage();
		}
	}
}


void CVaxVoIP::OnAddConferenceEvent(CString sIP, UINT nPort)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();
	
	if(pParentWnd->MessageBox("You have an incoming ADD Conversation request, Do you want to accept?", "ADD Conversation from IP: " + sIP, MB_ICONEXCLAMATION|MB_YESNO) == IDYES)
	{
		if(!AcceptAddInConf(sIP, nPort, 20))
		{
			ErrorMessage();
		}
	}
	else
	{
		if(!CancelAddInConf(sIP, nPort))
		{
			ErrorMessage();
		}
	}
}